package bdchain.api.grpc;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.15.0)",
    comments = "Source: bdchain/api/tx_ledger.proto")
public final class TransactionLedgerGrpc {

  private TransactionLedgerGrpc() {}

  public static final String SERVICE_NAME = "bdchain.api.TransactionLedger";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdchain.api.grpc.ClientVersionResponse> getClientVersionMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "ClientVersion",
      requestType = com.google.protobuf.Empty.class,
      responseType = bdchain.api.grpc.ClientVersionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdchain.api.grpc.ClientVersionResponse> getClientVersionMethod() {
    io.grpc.MethodDescriptor<com.google.protobuf.Empty, bdchain.api.grpc.ClientVersionResponse> getClientVersionMethod;
    if ((getClientVersionMethod = TransactionLedgerGrpc.getClientVersionMethod) == null) {
      synchronized (TransactionLedgerGrpc.class) {
        if ((getClientVersionMethod = TransactionLedgerGrpc.getClientVersionMethod) == null) {
          TransactionLedgerGrpc.getClientVersionMethod = getClientVersionMethod = 
              io.grpc.MethodDescriptor.<com.google.protobuf.Empty, bdchain.api.grpc.ClientVersionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.TransactionLedger", "ClientVersion"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.protobuf.Empty.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.ClientVersionResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new TransactionLedgerMethodDescriptorSupplier("ClientVersion"))
                  .build();
          }
        }
     }
     return getClientVersionMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.CreateLedgerRequest,
      bdchain.api.grpc.CreateLedgerResponse> getCreateLedgerMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CreateLedger",
      requestType = bdchain.api.grpc.CreateLedgerRequest.class,
      responseType = bdchain.api.grpc.CreateLedgerResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.CreateLedgerRequest,
      bdchain.api.grpc.CreateLedgerResponse> getCreateLedgerMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.CreateLedgerRequest, bdchain.api.grpc.CreateLedgerResponse> getCreateLedgerMethod;
    if ((getCreateLedgerMethod = TransactionLedgerGrpc.getCreateLedgerMethod) == null) {
      synchronized (TransactionLedgerGrpc.class) {
        if ((getCreateLedgerMethod = TransactionLedgerGrpc.getCreateLedgerMethod) == null) {
          TransactionLedgerGrpc.getCreateLedgerMethod = getCreateLedgerMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.CreateLedgerRequest, bdchain.api.grpc.CreateLedgerResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.TransactionLedger", "CreateLedger"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.CreateLedgerRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.CreateLedgerResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new TransactionLedgerMethodDescriptorSupplier("CreateLedger"))
                  .build();
          }
        }
     }
     return getCreateLedgerMethod;
  }

  private static volatile io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdchain.api.grpc.GetLedgersResponse> getGetLedgersMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetLedgers",
      requestType = com.google.protobuf.Empty.class,
      responseType = bdchain.api.grpc.GetLedgersResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdchain.api.grpc.GetLedgersResponse> getGetLedgersMethod() {
    io.grpc.MethodDescriptor<com.google.protobuf.Empty, bdchain.api.grpc.GetLedgersResponse> getGetLedgersMethod;
    if ((getGetLedgersMethod = TransactionLedgerGrpc.getGetLedgersMethod) == null) {
      synchronized (TransactionLedgerGrpc.class) {
        if ((getGetLedgersMethod = TransactionLedgerGrpc.getGetLedgersMethod) == null) {
          TransactionLedgerGrpc.getGetLedgersMethod = getGetLedgersMethod = 
              io.grpc.MethodDescriptor.<com.google.protobuf.Empty, bdchain.api.grpc.GetLedgersResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.TransactionLedger", "GetLedgers"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.protobuf.Empty.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.GetLedgersResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new TransactionLedgerMethodDescriptorSupplier("GetLedgers"))
                  .build();
          }
        }
     }
     return getGetLedgersMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.SendTransactionRequest,
      bdchain.api.grpc.SendTransactionResponse> getSendTransactionMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "SendTransaction",
      requestType = bdchain.api.grpc.SendTransactionRequest.class,
      responseType = bdchain.api.grpc.SendTransactionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.SendTransactionRequest,
      bdchain.api.grpc.SendTransactionResponse> getSendTransactionMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.SendTransactionRequest, bdchain.api.grpc.SendTransactionResponse> getSendTransactionMethod;
    if ((getSendTransactionMethod = TransactionLedgerGrpc.getSendTransactionMethod) == null) {
      synchronized (TransactionLedgerGrpc.class) {
        if ((getSendTransactionMethod = TransactionLedgerGrpc.getSendTransactionMethod) == null) {
          TransactionLedgerGrpc.getSendTransactionMethod = getSendTransactionMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.SendTransactionRequest, bdchain.api.grpc.SendTransactionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.TransactionLedger", "SendTransaction"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.SendTransactionRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.SendTransactionResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new TransactionLedgerMethodDescriptorSupplier("SendTransaction"))
                  .build();
          }
        }
     }
     return getSendTransactionMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static TransactionLedgerStub newStub(io.grpc.Channel channel) {
    return new TransactionLedgerStub(channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static TransactionLedgerBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    return new TransactionLedgerBlockingStub(channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static TransactionLedgerFutureStub newFutureStub(
      io.grpc.Channel channel) {
    return new TransactionLedgerFutureStub(channel);
  }

  /**
   */
  public static abstract class TransactionLedgerImplBase implements io.grpc.BindableService {

    /**
     */
    public void clientVersion(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.ClientVersionResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getClientVersionMethod(), responseObserver);
    }

    /**
     */
    public void createLedger(bdchain.api.grpc.CreateLedgerRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.CreateLedgerResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCreateLedgerMethod(), responseObserver);
    }

    /**
     */
    public void getLedgers(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.GetLedgersResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetLedgersMethod(), responseObserver);
    }

    /**
     */
    public void sendTransaction(bdchain.api.grpc.SendTransactionRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.SendTransactionResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getSendTransactionMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getClientVersionMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.protobuf.Empty,
                bdchain.api.grpc.ClientVersionResponse>(
                  this, METHODID_CLIENT_VERSION)))
          .addMethod(
            getCreateLedgerMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.CreateLedgerRequest,
                bdchain.api.grpc.CreateLedgerResponse>(
                  this, METHODID_CREATE_LEDGER)))
          .addMethod(
            getGetLedgersMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.protobuf.Empty,
                bdchain.api.grpc.GetLedgersResponse>(
                  this, METHODID_GET_LEDGERS)))
          .addMethod(
            getSendTransactionMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.SendTransactionRequest,
                bdchain.api.grpc.SendTransactionResponse>(
                  this, METHODID_SEND_TRANSACTION)))
          .build();
    }
  }

  /**
   */
  public static final class TransactionLedgerStub extends io.grpc.stub.AbstractStub<TransactionLedgerStub> {
    private TransactionLedgerStub(io.grpc.Channel channel) {
      super(channel);
    }

    private TransactionLedgerStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected TransactionLedgerStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new TransactionLedgerStub(channel, callOptions);
    }

    /**
     */
    public void clientVersion(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.ClientVersionResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getClientVersionMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void createLedger(bdchain.api.grpc.CreateLedgerRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.CreateLedgerResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCreateLedgerMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getLedgers(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.GetLedgersResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetLedgersMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void sendTransaction(bdchain.api.grpc.SendTransactionRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.SendTransactionResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getSendTransactionMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class TransactionLedgerBlockingStub extends io.grpc.stub.AbstractStub<TransactionLedgerBlockingStub> {
    private TransactionLedgerBlockingStub(io.grpc.Channel channel) {
      super(channel);
    }

    private TransactionLedgerBlockingStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected TransactionLedgerBlockingStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new TransactionLedgerBlockingStub(channel, callOptions);
    }

    /**
     */
    public bdchain.api.grpc.ClientVersionResponse clientVersion(com.google.protobuf.Empty request) {
      return blockingUnaryCall(
          getChannel(), getClientVersionMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.CreateLedgerResponse createLedger(bdchain.api.grpc.CreateLedgerRequest request) {
      return blockingUnaryCall(
          getChannel(), getCreateLedgerMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.GetLedgersResponse getLedgers(com.google.protobuf.Empty request) {
      return blockingUnaryCall(
          getChannel(), getGetLedgersMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.SendTransactionResponse sendTransaction(bdchain.api.grpc.SendTransactionRequest request) {
      return blockingUnaryCall(
          getChannel(), getSendTransactionMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class TransactionLedgerFutureStub extends io.grpc.stub.AbstractStub<TransactionLedgerFutureStub> {
    private TransactionLedgerFutureStub(io.grpc.Channel channel) {
      super(channel);
    }

    private TransactionLedgerFutureStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected TransactionLedgerFutureStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new TransactionLedgerFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.ClientVersionResponse> clientVersion(
        com.google.protobuf.Empty request) {
      return futureUnaryCall(
          getChannel().newCall(getClientVersionMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.CreateLedgerResponse> createLedger(
        bdchain.api.grpc.CreateLedgerRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCreateLedgerMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.GetLedgersResponse> getLedgers(
        com.google.protobuf.Empty request) {
      return futureUnaryCall(
          getChannel().newCall(getGetLedgersMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.SendTransactionResponse> sendTransaction(
        bdchain.api.grpc.SendTransactionRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getSendTransactionMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_CLIENT_VERSION = 0;
  private static final int METHODID_CREATE_LEDGER = 1;
  private static final int METHODID_GET_LEDGERS = 2;
  private static final int METHODID_SEND_TRANSACTION = 3;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final TransactionLedgerImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(TransactionLedgerImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_CLIENT_VERSION:
          serviceImpl.clientVersion((com.google.protobuf.Empty) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.ClientVersionResponse>) responseObserver);
          break;
        case METHODID_CREATE_LEDGER:
          serviceImpl.createLedger((bdchain.api.grpc.CreateLedgerRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.CreateLedgerResponse>) responseObserver);
          break;
        case METHODID_GET_LEDGERS:
          serviceImpl.getLedgers((com.google.protobuf.Empty) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.GetLedgersResponse>) responseObserver);
          break;
        case METHODID_SEND_TRANSACTION:
          serviceImpl.sendTransaction((bdchain.api.grpc.SendTransactionRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.SendTransactionResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class TransactionLedgerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    TransactionLedgerBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return bdchain.api.grpc.TransactionLedgerProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("TransactionLedger");
    }
  }

  private static final class TransactionLedgerFileDescriptorSupplier
      extends TransactionLedgerBaseDescriptorSupplier {
    TransactionLedgerFileDescriptorSupplier() {}
  }

  private static final class TransactionLedgerMethodDescriptorSupplier
      extends TransactionLedgerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    TransactionLedgerMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (TransactionLedgerGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new TransactionLedgerFileDescriptorSupplier())
              .addMethod(getClientVersionMethod())
              .addMethod(getCreateLedgerMethod())
              .addMethod(getGetLedgersMethod())
              .addMethod(getSendTransactionMethod())
              .build();
        }
      }
    }
    return result;
  }
}
